diff --git a/bgpd/bgp_flowspec.c b/bgpd/bgp_flowspec.c
index 70bdbaf0356f..6165bf892e72 100644
--- a/bgpd/bgp_flowspec.c
+++ b/bgpd/bgp_flowspec.c
@@ -189,13 +189,16 @@ int bgp_nlri_parse_flowspec(struct peer *peer, struct attr *attr,
 			zlog_info("%s", local_string);
 		}
 		/* Process the route. */
-		if (!withdraw)
+		if (!withdraw) {
 			bgp_update(peer, &p, 0, attr, afi, safi,
 				   ZEBRA_ROUTE_BGP, BGP_ROUTE_NORMAL, NULL,
 				   NULL, 0, 0, NULL);
-		else
+		} else {
 			bgp_withdraw(peer, &p, 0, afi, safi, ZEBRA_ROUTE_BGP,
 				     BGP_ROUTE_NORMAL, NULL, NULL, 0, NULL);
+		}
+
+		XFREE(MTYPE_TMP, temp);
 	}
 	return BGP_NLRI_PARSE_OK;
 }
